package com.nexirius.theteam.datacontroller;

import com.nexirius.framework.datacontroller.DataController;
import com.nexirius.framework.datamodel.DataModel;
import com.nexirius.framework.dataviewer.ViewerFactory;
import com.nexirius.theteam.datamodel.MainModel;

//
//Main DataController for The Team application
//
public class MainController extends DataController 
{
    //Constructor creates an instance of the MainModel. It gets the ViewerFactory from the
    //Application class and creates a DataViewer for the MainModel with it.
	public MainController(ViewerFactory factory)
		throws Exception
	{
		this.setDataViewer(factory.createDefaultEditor(new MainModel()));
	}
	//Method is called when a DataModelCommand of the associated DataModel or his children
	//is called or when the same method has been called on a child controller and returned false.
	//This implementation just prints out the fieldname of the DataModelCommand that has been called.
	public boolean doHandleMethodCall(String methodName, boolean fromChildController, DataModel source)
	{
		System.out.println(methodName);
		return false;
	}
    //Returns the application main model, which is the model associated to this controller.
	public MainModel getMainModel()
	{
		return (MainModel)getDataModel();
	}

}
