package com.nexirius.theteam.datamodel;

import com.nexirius.framework.application.DialogManager;
import com.nexirius.framework.datamodel.*;
import com.nexirius.theteam.persistence.FilePersistence;

//
//Model subclassing the EditListModel to store a list of addresses
//

public class AddressListModel extends EditListModel
{
    //Constructor
	AddressListModel()
	{
		super("AddressList", new AddressArrayModel());
	}
    //Returns the member id of the member this address list corresponds too, the condition
    //is that this list is embedded into a MemberModel.
	public String getMemberId()
	{
		return ((MemberModel)getParentDataModel()).getID();	
	}
    //
    //Command methods implementations (see EditListModel.java)
    //
    //Creates a new item and opens an editor in a popup window for it.
    //If user confirms, the item is made persistent and therefore added to the list.
	public DataModel addItem()
	{
		AddressModel address = new AddressModel();
		
		if (DialogManager.getPopupEditorAdaptor().popupEdit(address)) {
			FilePersistence.getInstance().create(address);
			
			MemberAddressModel ma = new MemberAddressModel(getMemberId(), address.getID());		
			FilePersistence.getInstance().create(ma);

			return address;
		}
		
		return null;
	}
    //Opens an editor in a popup window for the given item.
    //If user confirms the item is made persistant.
	public void editItem(DataModel model)
	{
		AddressModel a = (AddressModel)model;
		
		if (DialogManager.getPopupEditorAdaptor().popupEdit(a)) {
			 FilePersistence.getInstance().update(a);
		}
	}
}


