package com.nexirius.theteam.datamodel;

import com.nexirius.theteam.persistence.DBObjectModel;
import com.nexirius.util.CopyPairs;
import com.nexirius.framework.datamodel.*;

//
//Model storing mail address information, street/number, zip, city, state,
//all stored in StringModels. We are subclassing DBObjectModel for persistancy.

public class AddressModel extends DBObjectModel
{
    //child model fields
	StringModel street;
	StringModel zip;
	StringModel city;
	StringModel state;

	//constructor
	public AddressModel()
	{
		super("Address"); //default fieldname
		init();
	}

    //create and append child models
	private void init()
	{
		append(street = new StringModel("", "street"));
		append(zip = new StringModel("", "zip"));
		append(city = new StringModel("", "city"));
		append(state = new StringModel("", "state"));
	}

    //Duplication method
	public synchronized DataModel duplicate(DataModel instance, CopyPairs copyPairs)
	{
		if (instance == null) {
			instance = new AddressModel();
		}

		return super.duplicate(instance, copyPairs);
	}
}

