package com.nexirius.theteam.datamodel;

import com.nexirius.theteam.persistence.DBObjectModel;
import com.nexirius.framework.datamodel.*;
//
//Model stores to IDs, member ID and address ID in StringModels
//
public class MemberAddressModel extends DBObjectModel
{
    //child model fields
	StringModel memberId;
	StringModel addressId;

    //Constructor
	public MemberAddressModel()
	{
		super("MemberAddress");
		init();
	}
    //Constructor with member ID and address ID as arguments
	public MemberAddressModel(String memberId, String addressId)
	{
		super("MemberAddress");
		init();
		
		setMemberId(memberId);
		setAddressId(addressId);
	}
    //Creates and appends child models
	private void init()
	{
		append(memberId = new StringModel("", "memberId"));
		append(addressId = new StringModel("", "addressId"));
	}
    //
    //public getters/setters for member & address ID
    //
	public String getAddressId()
	{
		return addressId.getText();
	}
	
	public void setAddressId(String i)
	{
		addressId.setText(i);
	}

	public void setMemberId(String i)
	{
		memberId.setText(i);
	}
}

