package com.nexirius.theteam.datamodel;

import com.nexirius.framework.application.DialogManager;
import com.nexirius.framework.datamodel.*;
import com.nexirius.theteam.persistence.FilePersistence;
import com.nexirius.theteam.persistence.TeamPersistence;

//
//Model subclassing EditListModel to store an array of MemberModels
//

public class MemberListModel extends EditListModel
{
    //Constructor creates new MemberArrayModel and calls super to create the EditListModel
	public MemberListModel()
	{
		super("MemberList", new MemberArrayModel());
	}
    //
    //Command method implementations (see EditListModel.java)
    //
    //Creates a new member model and opens an editor for the embedded person model
    //in a popup window. If user confirms, the person model is made persitent and the id is
    //stored in the member model.
	public DataModel addItem()
	{
		MemberModel member = new MemberModel();
		
		if (DialogManager.getPopupEditorAdaptor().popupEdit(member.getPerson())) {
			FilePersistence.getInstance().create(member.getPerson());
			member.setPersonId(member.getPerson().getID());
			FilePersistence.getInstance().create(member);

			return member;
		}
		
		return null;
	}
    //Loads addresses and phone information for a given member model
    //and opens an editor in a popup window for it. If user confirms,
    //the member model is made persistant. 
	public void editItem(DataModel model)
	{
		MemberModel member = (MemberModel)model;
					
		TeamPersistence.getAddressesForMember(member);
		TeamPersistence.getPhonesForMember(member);
		
		DialogManager.getPopupEditorAdaptor().noDuplicatePopupEdit(member, null, null);
		FilePersistence.getInstance().update(member);
		FilePersistence.getInstance().update(member.getPerson());
	}
}

