package com.nexirius.theteam.datamodel;

import com.nexirius.theteam.persistence.DBObjectModel;
import com.nexirius.framework.datamodel.*;
//
//Model stores corresponding phone & member ID in StringModels
//
public class MemberPhoneModel extends DBObjectModel
{
    //child model fields
	StringModel memberId;
	StringModel phoneId;

	//Constructor
	public MemberPhoneModel()
	{
		super("MemberPhone");//default fieldname
		init();
	}
    //Constructor with ids as argument.
	public MemberPhoneModel(String memberId, String phoneId)
	{
		super("MemberPhone");
		init();
		
		setMemberId(memberId);
		setPhoneId(phoneId);
	}
    //Creates and appends child models.
	private void init()
	{
		append(memberId = new StringModel("", "memberId"));
		append(phoneId = new StringModel("", "addressId"));
	}
    //
    //Public getters/setters for member & phone id
    //
	public String getPhoneId()
	{
		return phoneId.getText();
	}
	
	public void setPhoneId(String i)
	{
		phoneId.setText(i);
	}

	public void setMemberId(String i)
	{
		memberId.setText(i);
	}
}

