package com.nexirius.theteam.datamodel;

import com.nexirius.theteam.persistence.DBObjectModel;
import com.nexirius.util.CopyPairs;
import com.nexirius.framework.datamodel.*;

//
//Model storing informaton about a person, respectivly the firstname, lastname, full name,
//birthdate and a picture. We are subclassing DBObjectModel for persistancy.
//

public class PersonModel extends DBObjectModel
{
    //Child model fields
	StringModel name;
	StringModel firstname;
	ConcatModel fullname;
	StandardDateModel birthdate;
	FileNameModel picture;

	public PersonModel()
	{
		super("Person"); //Default fieldname
		init();
	}

    //Create and append child models
	private void init()
	{
		append(name = new StringModel("", "name"));
		append(firstname = new StringModel("", "firstname"));
		append(fullname = new ConcatModel("fullname"));
		fullname.addSummand(firstname);
		fullname.addSummand(name);
		append(birthdate = new StandardDateModel("birthdate"));
		append(picture = new FileNameModel("", "picture"));
	}
    //Duplication method
	public synchronized DataModel duplicate(DataModel instance, CopyPairs copyPairs)
	{
		if (instance == null) {
			instance = new PersonModel();
		}

		return super.duplicate(instance, copyPairs);
	}
}

