package com.nexirius.theteam.datamodel;

import com.nexirius.framework.application.DialogManager;
import com.nexirius.framework.datamodel.*;
import com.nexirius.theteam.persistence.FilePersistence;

//
//Model subclassing EditListModel to store a list of phone numbers in an array
//

public class PhoneListModel extends EditListModel
{
    //Constructor creating the list and calling the super constructor with it
	PhoneListModel()
	{
		super("PhoneList", new PhoneArrayModel());
	}
	//Returns the member id of the corresponding member under the conditon that
	//this list is embedded into a MemberModel
	public String getMemberId()
	{
		return ((MemberModel)getParentDataModel()).getID();	
	}
    //
    //Command methods implementations (see EditListModel.java)
    //
    //Creates a new item and opens an editor in a popup window for it.
    //If user confirms, the item is made persistent and therefore added to the list.
	public DataModel addItem()
	{
		PhoneModel phone = new PhoneModel();
		
		if (DialogManager.getPopupEditorAdaptor().popupEdit(phone)) {
			FilePersistence.getInstance().create(phone);
			
			MemberPhoneModel ma = new MemberPhoneModel(getMemberId(), phone.getID());		
			FilePersistence.getInstance().create(ma);

			return phone;
		}
		
		return null;
	}
    //Opens an editor in a popup window for the given item.
    //If user confirms the item is made persistant.
	public void editItem(DataModel model)
	{
		PhoneModel p = (PhoneModel)model;
		
		if (DialogManager.getPopupEditorAdaptor().popupEdit(p)) {
			 FilePersistence.getInstance().update(p);
		}
	}
}

