package com.nexirius.theteam.datamodel;

import com.nexirius.theteam.persistence.DBObjectModel;
import com.nexirius.util.CopyPairs;

import com.nexirius.framework.datamodel.*;

//
//DataModel representing a phone number with a description.
//Both information is stored in a StringModel. We are subclassing DBObjectModel,
//wich is itself subclassing a StructModel.
//

public class PhoneModel extends DBObjectModel
{
    //Child model fields
	StringModel description;
	StringModel number;

	//Constructor
	public PhoneModel()
	{
		super("Phone");  //Default fieldname
		init();
	}

    //Create and append child models
	private void init()
	{
		append(description = new StringModel("", "description"));
		append(number = new StringModel("", "number"));
	}

	//Duplication method
	public synchronized DataModel duplicate(DataModel instance, CopyPairs copyPairs)
	{
		if (instance == null) {
			instance = new PhoneModel();
		}

		return super.duplicate(instance, copyPairs);
	}
}

