package com.nexirius.theteam.layout;

import com.nexirius.framework.command.*;
import com.nexirius.framework.datamodel.*;
import com.nexirius.framework.dataeditor.*;
import com.nexirius.framework.dataviewer.*;
import com.nexirius.framework.layout.*;

public class ExampleLayout extends StructureLayoutItem
{
	protected int totalWidth = 600;
	protected int totalHeight = 500;
	protected int x = 0;
	protected int y = 0;

	protected int left = 20;
	protected int right = 20;
	protected int top = 20;
	protected int bottom = 20;
	public int wdialog = totalWidth - left - right;
	public int wlabel = wdialog / 3;
	public int wfield = wdialog - wlabel;
	public int wbutton = wlabel / 2;
	public int hfield = 20;
	public int hlabel = 20;
	public int hbutton = hfield;

	protected MultiplePropertyEntry labelProps = new MultiplePropertyEntry();

	public ExampleLayout()
	{
		initProperties();

		y = hlabel;
		appendField("BooleanModel", hfield);
		appendField("CurrencyModel;Amount", hfield);
		appendSplitField("CurrencyWithSelectorModel;Amount", "CurrencyWithSelectorModel;CurrencySelector", "CurrencyWithSelectorModel", 0.7);
		appendField("DateModel", hfield);
		appendField("DayMonthYearModel", hfield);
		appendField("DirNameModel", hfield);
		appendField("DoubleModel", hfield);
		appendField("FileNameModel", hfield);
		appendField("ImageModel", 5*hfield);
		appendField("IntModel", hfield);
		appendField("LimitIntModel", hfield);
		appendField("LimitStringModel", hfield);
		appendField("PasswordModel", hfield);
		appendField("RoundedDoubleModel", hfield);
		appendField("SimpleArrayModel", 5*hfield);
		appendField("StringModel", hfield);
		appendField("TextModel", 5*hfield);
		appendField("TrendModel", 5*hfield);
		appendField("command", hfield);
		int h = y + hlabel;

		y = 0;
		appendFrame("Example", h);

		//setSize(totalWidth, h + 2 * hlabel);
	}

	public void appendLabel(String name)
	{
		x = left;
		append(new LabelLayoutItem(name, x, y, wlabel, hlabel, labelProps));
		x += wlabel;
	}

	public void appendField(String name, int height)
	{
		appendLabel(name);
		append(new StructureFieldLayout(name, x, y, wfield, height, null, null, false, null, null));
		y += height;
	}

	public void appendSplitField(String name1, String name2, String label, double split)
	{
		int wfield1 = (int)(wfield * split);
		int wfield2 = wfield - wfield1;

		appendLabel(label);
		append(new StructureFieldLayout(name1, x, y, wfield1, hfield, null, null, false, null, null));
		x += wfield1;
		append(new StructureFieldLayout(name2, x, y, wfield2, hfield, null, null, false, null, null));
		y += hfield;
	}

	public void appendFrame(String title, int height)
	{
		append(new TitledBorderLayoutItem(title, left/2 , y, wdialog + left/2 + right/2, height));
	}

	private void initProperties()
	{
		labelProps.append(new SinglePropertyEntry("Font", "Arial-12"));
		labelProps.append(new SinglePropertyEntry("Foreground", "labelForeground"));
		labelProps.append(new SinglePropertyEntry("Background", "labelBackground"));
		labelProps.append(new SinglePropertyEntry("Alignment", "-1"));
	}
}

