package com.nexirius.theteam.layout;

import com.nexirius.framework.command.*;
import com.nexirius.framework.datamodel.*;
import com.nexirius.framework.dataeditor.*;
import com.nexirius.framework.dataviewer.*;
import com.nexirius.framework.layout.*;


public class MainLayout extends StandardLayout
{
	double zuwWidth;
	double zuwHeight;

	double tableWidth;
	double tableHeight;

	public MainLayout()
	{
		setBigFrame();

		double waddress = 25.0;
		double listHeight = 20.0;

		append(new StructureFieldLayout("MemberList", x, y, 0, 0, null, new EditListLayout(wframe, listHeight, "MembersTitle", "MemberArray", new MemberArrayLayout(w(wframe))), false, null, null));

		down(listHeight);
		down(hfield);

		append(new StructureFieldLayout("Member", x, y, 0, 0, new StructViewerCreator(), new MemberViewerLayout(waddress), false, null, null));

		double wpicture = 15;
		double hpicture = 25;

		right(waddress);
		append(new StructureFieldLayout("Member;Person;picture", x, y, w(wpicture), h(hpicture), new MyImageViewerCreator(), null, false, null, null));

		left(waddress);
		down(7 * hfield);

//		append(new StructureFieldLayout("Address", x, y, 0, 0, null, new AddressLayout(waddress), false, null, null));
		append(new StructureFieldLayout("Address", x, y, 0, 0, new StructViewerCreator(), new AddressLayout(waddress), false, null, null));

		down(7 * hfield);

		defaultSize();
	}

	class MyImageViewerCreator extends ImageViewerCreator
	{
		public DataViewer createViewer(Viewable model)
		{
			ImageViewer ret = (ImageViewer)super.createViewer(model);

			ret.setResizePanel(true);

			return ret;
		}
	}
}
