package com.nexirius.theteam.layout;

import java.awt.GridBagConstraints;
import java.awt.Insets;

import com.nexirius.framework.datamodel.*;
import com.nexirius.framework.dataviewer.*;
import com.nexirius.framework.layout.GridBagLayoutItem;

public class PersonLayout extends StandardLayout
{
	public PersonLayout()
	{
		GridBagConstraints top = new GridBagConstraints(0, 0, 0, 0, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(10, 10, 10, 10), 0, 0);
		GridBagConstraints bot = new GridBagConstraints(0, 0, 0, 0, 1.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 10, 10, 10), 0, 0);
		
		append(new GridBagLayoutItem(null, 0, 0, 1, 1, null, new TopLayout(), false, "top", null, top));
		append(new GridBagLayoutItem("picture", 0, 1, 1, 1, new MyImageViewerCreator(), null, false, "picture", null, bot));

		defaultSize();
	}
	
	class MyImageViewerCreator extends ImageViewerCreator
	{
		public DataViewer createViewer(Viewable model)
		{
			ImageViewer ret = (ImageViewer)super.createViewer(model);

			ret.setResizePanel(true);

			return ret;
		}
	}

	class TopLayout extends StandardLayout
	{
		public TopLayout()
		{
			appendFrame("", 4.0);
			appendTextField("name");
			appendTextField("firstname");
			appendNumberField("birthdate");
			appendTextField("picture");
			endFrame();
		}
	}
}

