package com.nexirius.theteam.persistence;

//
//Interface representing a database object
//

public interface DBObject {

    //Static fields
	public static final String FIELD_ID = "ID";
	public static final String FIELD_VERSION = "VERSION";

    //Public setter/getter interface for ID & version
	public void setID(String id);
	public String getID();
	
	public void setVersion(String version);
	public String getVersion();

    //Compare object by age
	/**
	 * compare the age of an instance with another version
	 * @param version  
	 * @return 0 if the versions are the same, if this is older return -1 if theis is younger then return 1
	 */
	public int compareVersion(String version);

	//Drag/Drop data into object
	public String dragData() throws Exception;
	public void dropData(String data) throws Exception;

    //Access object fields by name 	
	/**
	 * access a certain field by field name
	 * @param propertyName
	 * @return
	 */
	public String getProperty(String propertyName);
}
