package com.nexirius.theteam.persistence;

import com.nexirius.framework.datamodel.ArrayModel;
import com.nexirius.theteam.datamodel.*;
import com.nexirius.util.SortedVector;
//
//TeamPersistance manages the persistance on the file system of the
//list items and member data managed by The Team application.
//
public class TeamPersistence
{
    //Method fills up array model with list items from file.
	public static void getAllMembers(ArrayModel members)
	{
	    //clear given array
		members.clear();
		//Create vector of all list items we find in our source on filesystem.
		SortedVector all = FilePersistence.getInstance().getAll(MemberModel.class);
		//Append all items in the vector to the array
		for (MemberModel m = (MemberModel)all.firstObject(); m != null; m = (MemberModel)all.nextObject()) {
			members.append(m);
			//set id right
			m.getPerson().setID(m.getPersonId());
			//throw all stuff we append to the list back into the persistance engine
			FilePersistence.getInstance().read(m.getPerson());
		}
	}
    //Method drops all addresses of a certain member from file into the given member model
	public static void getAddressesForMember(MemberModel member)
	{
	    //clear address array of member model
		member.getAddresses().clear();
		//get vector with all addresses of this member that are on file
		SortedVector all = FilePersistence.getInstance().getAll(MemberAddressModel.class, "memberId", member.getID());
		//append all addresses to the member model address array and drop addresses back to file
		for (MemberAddressModel a = (MemberAddressModel)all.firstObject(); a != null; a = (MemberAddressModel)all.nextObject()) {
			AddressModel am = (AddressModel)FilePersistence.getInstance().read(AddressModel.class, a.getAddressId());
			
			member.getAddresses().append(am);
		}
	}
    //Method drops all phone numbers of a certain member from file into the given member model
	public static void getPhonesForMember(MemberModel member)
	{
	    //clear phone number array of member model
		member.getPhones().clear();
		//get vector with all phone numbers of this member from file
		SortedVector all = FilePersistence.getInstance().getAll(MemberPhoneModel.class, "memberId", member.getID());
		//append all phone numbers to phone number array of member model and drop phone numbers back to file
		for (MemberPhoneModel a = (MemberPhoneModel)all.firstObject(); a != null; a = (MemberPhoneModel)all.nextObject()) {
			PhoneModel am = (PhoneModel)FilePersistence.getInstance().read(PhoneModel.class, a.getPhoneId());
			
			member.getPhones().append(am);
		}
	}
}
